//+------------------------------------------------------------------+
//|                                  MoneyDeepLevelsAutoShadedV4.mq4 |
//|                                  Coded By, Brooky Indicators.com |
//|  http://www.forexfactory.com/showthread.php?t=308230 MoneyDeep   |
//+------------------------------------------------------------------+

#property link      "www.Brooky-Indicators.com"

#property indicator_chart_window

extern string Switch_1 = "SwitchBox: Settings below";
extern bool   SeeShadeBox = true;
extern bool   SeeArcs = true;
extern string Indi_CopyOnChart = "a";
extern bool   UseAutoTfHiLos = false;
extern bool   SetBarOnHigh = true;
extern string PriceCycleNote = "Circles 1 to 6 ONLY";
extern int    SelectCircleToUse = 1;
extern bool   SeeTimeCycles = true;
extern bool   AutoCycleBars = true;
extern string GridNote = "Cycle Bars MUST be ON 4 Grid";
extern bool   SeeGrid = true;

extern bool   SeeUpperCycleLines = true;
extern bool   SeeLowerCycleLines = true;

extern double WierdSymbolPointMultiplier = 1;



extern string Switch_1a = "Shade Options";
extern color  ShadeColor  = C'45,51,57';
extern string Switch_1b = "Arc Options";
extern color  ArcColor  = Yellow;
extern double ArcRatio = 40;

 
extern string Switch_1c = "Auto TF Options";
extern int    AutoTf2Use     = 1440;
extern int    MtfBarBack     = 8;


extern string Switch_1d = "Cycle Options";
extern double   AutoCycleDivisor = 4;
extern int      TimeCycleBars = 34;//


extern color  TimeCycleColor = Gray;
extern int    TimeCycleSize = 1;
extern int    TimeCycleStyle = 0;//

extern string Switch_1e = "Grid Options";
extern color  GridColor = SlateGray;
extern int    GridSize = 1;
extern int    GridStyle = 2;


extern string Switch_1f = "Color Options";


//========== degreecolors
extern color  Degree_45  = White;
extern color  Degree_90  = Purple;
extern color  Degree_120 = Green;
extern color  Degree_135 = White;
extern color  Degree_180 = Red;
extern color  Degree_225 = White;
extern color  Degree_240 = Green;
extern color  Degree_270 = Purple;
extern color  Degree_315 = White;
extern color  Degree_360 = Blue;

extern int    CalcSize=1;
extern int    CalcStyle=0;
extern color  ControlBarColor=Red;
extern color  CalcDnColor=DodgerBlue;
extern color  CalcUpColor=Red;

extern string Switch_1g = "Ratio Options";


extern string    Circle1 = "Circle 1 Ratios";
extern double    C1ratio1 = 0.0125;
extern double    C1ratio2 = 0.0250;
extern double    C1ratio3 = 0.0333;
extern double    C1ratio4 = 0.0375;
extern double    C1ratio5 = 0.0500;
extern double    C1ratio6 = 0.0625;
extern double    C1ratio7 = 0.0667;
extern double    C1ratio8 = 0.0750;
extern double    C1ratio9 = 0.0875;
extern double    C1ratio10 =0.1000;

extern string    Circle2 = "Circle 2 Ratios";
extern double    C2ratio1 = 0.1125;
extern double    C2ratio2 = 0.1250;
extern double    C2ratio3 = 0.1333;
extern double    C2ratio4 = 0.1375;
extern double    C2ratio5 = 0.1500;
extern double    C2ratio6 = 0.1625;
extern double    C2ratio7 = 0.1666;
extern double    C2ratio8 = 0.1750;
extern double    C2ratio9 = 0.1875;
extern double    C2ratio10 = 1.000;

extern string    Circle3 = "Circle 3 Ratios";
extern double    C3ratio1 = 0.2125;
extern double    C3ratio2 = 0.2250;
extern double    C3ratio3 = 0.2333;
extern double    C3ratio4 = 0.2375;
extern double    C3ratio5 = 0.2500;
extern double    C3ratio6 = 0.2625;
extern double    C3ratio7 = 0.2666;
extern double    C3ratio8 = 0.2750;
extern double    C3ratio9 = 0.2875;
extern double    C3ratio10 = 2.000;

extern string    Circle4 = "Circle 4 Ratios";
extern double    C4ratio1 = 0.3125;
extern double    C4ratio2 = 0.3250;
extern double    C4ratio3 = 0.3333;
extern double    C4ratio4 = 0.3375;
extern double    C4ratio5 = 0.3500;
extern double    C4ratio6 = 0.3625;
extern double    C4ratio7 = 0.3666;
extern double    C4ratio8 = 0.3750;
extern double    C4ratio9 = 0.3875;
extern double    C4ratio10 = 3.000;

extern string    Circle5 = "Circle 5 Ratios";
extern double    C5ratio1 = 0.4125;
extern double    C5ratio2 = 0.4250;
extern double    C5ratio3 = 0.4333;
extern double    C5ratio4 = 0.4375;
extern double    C5ratio5 = 0.4500;
extern double    C5ratio6 = 0.4625;
extern double    C5ratio7 = 0.4666;
extern double    C5ratio8 = 0.4750;
extern double    C5ratio9 = 0.4875;
extern double    C5ratio10 = 4.000;

extern string    Circle6 = "Circle 6 Ratios";
extern double    C6ratio1 = 0.5125;
extern double    C6ratio2 = 0.5250;
extern double    C6ratio3 = 0.5333;
extern double    C6ratio4 = 0.5375;
extern double    C6ratio5 = 0.5500;
extern double    C6ratio6 = 0.5625;
extern double    C6ratio7 = 0.5666;
extern double    C6ratio8 = 0.5750;
extern double    C6ratio9 = 0.5875;
extern double    C6ratio10 = 5.000;


extern string Tf_ValuesInfo =" Tf Value Hints",
PERIOD_M1.="1.. 1 minute.", 
PERIOD_M5.=" 5.. 5 minutes. ",
PERIOD_M15.=" 15.. 15 minutes. ",
PERIOD_M30.=" 30.. 30 minutes. ",
PERIOD_H1.=" 60.. 1 hour. ",
PERIOD_H4.=" 240.. 4 hour. ",
PERIOD_D1.=" 1440.. Daily. ",
PERIOD_W1.=" 10080.. Weekly. ",
PERIOD_MN1.=" 43200.. Monthly. ",
zero =" 0.. Timeframe used on the chart."; 
extern bool   SeeComment = true;

//---vars
double    ratio1,ratio2,ratio3,ratio4,ratio5,ratio6,ratio7,ratio8,ratio9,ratio10;

int Cycle_Bars;
static double thelow,thehigh;

string txtUp1="High",txtUp2="U_45",txtUp3="U_90",txtUp4="U_120",txtUp5="U_135",txtUp6="U_180",txtUp7="U_225",txtUp8="U_240",txtUp9="U_270",txtUp10="U_315",txtUp11="U_360";
string txtDn1="Low",txtDn2="D_45",txtDn3="D_90",txtDn4="D_120",txtDn5="D_135",txtDn6="D_180",txtDn7="D_225",txtDn8="D_240",txtDn9="D_270",txtDn10="D_315",txtDn11="D_360";
double Up1,Up2,Up3,Up4,Up5,Up6,Up7,Up8,Up9,Up10;
double Dn1,Dn2,Dn3,Dn4,Dn5,Dn6,Dn7,Dn8,Dn9,Dn10;


string IndiCopyOnChart = "";
string ControlBar="ControlBar";
string Cycler="Cycler";
string Grid="Gridit";
string Grid2="Gridit2";
double price1,price2,Points;
static datetime lowtime,hightime;
static double CbarRange;
int hval1;
int SetBarOn;
int lval1;
int  val1;

string Gbox1 = "GannBox1";

string GCirc1 = "GannCirc1";

string Arc1 = "Garc_1";
string Arc2 = "Garc_2";

//---------------------------------------------+
int init()
  {
 //--------------------points calc  to work out square size 
      if (Digits == 4 || Digits == 2) 
     {
       
       Points = WierdSymbolPointMultiplier*Point;
     }
  
   if (Digits == 5 || Digits == 3) 
     {     
       
       Points = WierdSymbolPointMultiplier*Point*10;
     }
     
 IndicatorShortName("MD_Tf_"+DoubleToStr(Period(),0)+" Indi_"+IndiCopyOnChart);

 //-------------------- 
 if(UseAutoTfHiLos)
 {
 IndiCopyOnChart = StringConcatenate(Indi_CopyOnChart,"_Tf_",DoubleToStr(AutoTf2Use,0));
 
 }else IndiCopyOnChart = StringConcatenate(Indi_CopyOnChart,"_",DoubleToStr(Period(),0));
 
 
   return(0);
  }
//---------------------------------------------+
int deinit()
  {
   
   ObjectDelete(txtUp1+IndiCopyOnChart);
   ObjectDelete(txtUp2+IndiCopyOnChart);
   ObjectDelete(txtUp3+IndiCopyOnChart);
   ObjectDelete(txtUp4+IndiCopyOnChart);
   ObjectDelete(txtUp5+IndiCopyOnChart);
   ObjectDelete(txtUp6+IndiCopyOnChart);
   ObjectDelete(txtUp7+IndiCopyOnChart);
   ObjectDelete(txtUp8+IndiCopyOnChart);
   ObjectDelete(txtUp9+IndiCopyOnChart);
   ObjectDelete(txtUp10+IndiCopyOnChart);
   ObjectDelete(txtUp11+IndiCopyOnChart);

   ObjectDelete(txtDn1+IndiCopyOnChart);
   ObjectDelete(txtDn2+IndiCopyOnChart);
   ObjectDelete(txtDn3+IndiCopyOnChart);
   ObjectDelete(txtDn4+IndiCopyOnChart);
   ObjectDelete(txtDn5+IndiCopyOnChart);
   ObjectDelete(txtDn6+IndiCopyOnChart);
   ObjectDelete(txtDn7+IndiCopyOnChart);
   ObjectDelete(txtDn8+IndiCopyOnChart);
   ObjectDelete(txtDn9+IndiCopyOnChart);
   ObjectDelete(txtDn10+IndiCopyOnChart);
   ObjectDelete(txtDn11+IndiCopyOnChart);
   ObjectDelete(Cycler+IndiCopyOnChart);
   ObjectDelete(Grid+IndiCopyOnChart);
   ObjectDelete(Grid2+IndiCopyOnChart);
   
   ObjectDelete(Gbox1+IndiCopyOnChart);
   
   ObjectDelete(GCirc1+IndiCopyOnChart);
   
   ObjectDelete(Arc1+IndiCopyOnChart);
   ObjectDelete(Arc2+IndiCopyOnChart);
      
   Comment("");
   return(0);
  }
//---------------------------------------------+

int start()
  {
  
        int counted_bars;
   int limit=Bars-counted_bars;
      
   if(counted_bars>0) limit++;
   
   for(int i=limit; i>0; i--)


{

    val1=iBarShift(NULL,0,iTime(NULL,AutoTf2Use,i+MtfBarBack-1),false);
    
    hval1=iHighest(NULL,0,MODE_HIGH,AutoTf2Use/Period(),i+val1);
    lval1=iLowest(NULL,0,MODE_LOW,AutoTf2Use/Period(),i+val1);
    if(!SetBarOnHigh)
    {
     SetBarOn=iLowest(NULL,0,MODE_LOW,AutoTf2Use/Period(),i+val1);
     }
    if(SetBarOnHigh)
    {
     SetBarOn=iHighest(NULL,0,MODE_HIGH,AutoTf2Use/Period(),i+val1);
     } 
     
}  
   
  if(SelectCircleToUse<1 || SelectCircleToUse>6){SelectCircleToUse=1; Alert("Selected Circle Number Invalid; Have Auto set to Circle 1");}
  if(SelectCircleToUse ==1)
  {
   ratio1 = C1ratio1;
   ratio2 = C1ratio2;
   ratio3 = C1ratio3;
   ratio4 = C1ratio4;
   ratio5 = C1ratio5;
   ratio6 = C1ratio6;
   ratio7 = C1ratio7;
   ratio8 = C1ratio8;
   ratio9 = C1ratio9;
   ratio10 = C1ratio10;
  }
  if(SelectCircleToUse ==2)
  {
   ratio1 = C2ratio1;
   ratio2 = C2ratio2;
   ratio3 = C2ratio3;
   ratio4 = C2ratio4;
   ratio5 = C2ratio5;
   ratio6 = C2ratio6;
   ratio7 = C2ratio7;
   ratio8 = C2ratio8;
   ratio9 = C2ratio9;
   ratio10 = C2ratio10;
  }
  if(SelectCircleToUse ==3)
  {
   ratio1 = C3ratio1;
   ratio2 = C3ratio2;
   ratio3 = C3ratio3;
   ratio4 = C3ratio4;
   ratio5 = C3ratio5;
   ratio6 = C3ratio6;
   ratio7 = C3ratio7;
   ratio8 = C3ratio8;
   ratio9 = C3ratio9;
   ratio10 = C3ratio10;
  } 
  if(SelectCircleToUse ==4)
  {
   ratio1 = C4ratio1;
   ratio2 = C4ratio2;
   ratio3 = C4ratio3;
   ratio4 = C4ratio4;
   ratio5 = C4ratio5;
   ratio6 = C4ratio6;
   ratio7 = C4ratio7;
   ratio8 = C4ratio8;
   ratio9 = C4ratio9;
   ratio10 = C4ratio10;
  }   
  if(SelectCircleToUse ==5)
  {
   ratio1 = C5ratio1;
   ratio2 = C5ratio2;
   ratio3 = C5ratio3;
   ratio4 = C5ratio4;
   ratio5 = C5ratio5;
   ratio6 = C5ratio6;
   ratio7 = C5ratio7;
   ratio8 = C5ratio8;
   ratio9 = C5ratio9;
   ratio10 = C5ratio10;
  }  
  if(SelectCircleToUse ==6)
  {
   ratio1 = C6ratio1;
   ratio2 = C6ratio2;
   ratio3 = C6ratio3;
   ratio4 = C6ratio4;
   ratio5 = C6ratio5;
   ratio6 = C6ratio6;
   ratio7 = C6ratio7;
   ratio8 = C6ratio8;
   ratio9 = C6ratio9;
   ratio10 = C6ratio10;
  } 
  
 price1=0;
 price2=0;         
     
if(ObjectFind(ControlBar+IndiCopyOnChart)!=0)
{

      int startbar = (Cycle_Bars*AutoCycleDivisor)+2;
      ObjectCreate(ControlBar+IndiCopyOnChart,OBJ_TREND,0,Time[startbar+5],High[startbar],Time[startbar],Low[startbar]-((High[startbar]-Low[startbar])*3));      
      ObjectSet(ControlBar+IndiCopyOnChart, OBJPROP_COLOR,ControlBarColor);
      ObjectSet(ControlBar+IndiCopyOnChart, OBJPROP_WIDTH ,3);      
      ObjectSet(ControlBar+IndiCopyOnChart, OBJPROP_RAY ,False);

}
if(UseAutoTfHiLos && ObjectFind(ControlBar+IndiCopyOnChart)==0)
{

  ObjectSet(ControlBar+IndiCopyOnChart, OBJPROP_PRICE1 ,High[hval1]); 
 ObjectSet(ControlBar+IndiCopyOnChart, OBJPROP_PRICE2 ,Low[lval1]);
 
 ObjectSet(ControlBar+IndiCopyOnChart, OBJPROP_TIME1 ,Time[SetBarOn]);
 ObjectSet(ControlBar+IndiCopyOnChart, OBJPROP_TIME2 ,Time[SetBarOn]);
 ObjectSet(ControlBar+IndiCopyOnChart, OBJPROP_COLOR,ControlBarColor);
 
 WindowRedraw();
}

  if(AutoCycleBars)
  {
  Cycle_Bars=MathRound(CbarRange/AutoCycleDivisor);
  
  }
    if(!AutoCycleBars)
  {
  Cycle_Bars=TimeCycleBars;
  
  }
//-------------
if(ObjectFind(ControlBar+IndiCopyOnChart)==0)
{

   price1=ObjectGet(ControlBar+IndiCopyOnChart, OBJPROP_PRICE1);
   price2=ObjectGet(ControlBar+IndiCopyOnChart, OBJPROP_PRICE2);
  
  thelow=MathMin(price1,price2);
  thehigh=MathMax(price1,price2);
  //-------------------Auto Cbars
  CbarRange=MathMax((thehigh-thelow),0.0002)/Points;
   
  

  if(thelow==price1)lowtime=ObjectGet(ControlBar+IndiCopyOnChart, OBJPROP_TIME1);else  lowtime=ObjectGet(ControlBar+IndiCopyOnChart, OBJPROP_TIME2);
  if(thehigh==price2)hightime=ObjectGet(ControlBar+IndiCopyOnChart, OBJPROP_TIME2);else  hightime=ObjectGet(ControlBar+IndiCopyOnChart, OBJPROP_TIME1);
  ObjectSet(ControlBar+IndiCopyOnChart, OBJPROP_COLOR,ControlBarColor);
  
  if(SeeTimeCycles && ObjectFind(Cycler+IndiCopyOnChart)!=0)
  {
      
      ObjectCreate(Cycler+IndiCopyOnChart,OBJ_CYCLES,0,Time[iBarShift(NULL,0,lowtime)-Cycle_Bars],price1,lowtime,price1);      
      ObjectSet(Cycler+IndiCopyOnChart, OBJPROP_COLOR,TimeCycleColor);
      ObjectSet(Cycler+IndiCopyOnChart, OBJPROP_WIDTH ,TimeCycleSize);
      ObjectSet(Cycler+IndiCopyOnChart, OBJPROP_STYLE ,TimeCycleStyle);     
      
      if(SeeGrid && ObjectFind(Grid+IndiCopyOnChart)!=0)
      {
      ObjectCreate(Grid+IndiCopyOnChart,OBJ_GANNGRID,0,Time[iBarShift(NULL,0,lowtime)-Cycle_Bars],thelow,lowtime,thehigh);      
      ObjectSet(Grid+IndiCopyOnChart, OBJPROP_COLOR,GridColor);
      ObjectSet(Grid+IndiCopyOnChart, OBJPROP_WIDTH ,GridSize);
      ObjectSet(Grid+IndiCopyOnChart, OBJPROP_STYLE ,GridStyle);

      ObjectCreate(Grid2+IndiCopyOnChart,OBJ_GANNGRID,0,Time[iBarShift(NULL,0,lowtime)-Cycle_Bars],thehigh,lowtime,thelow);      
      ObjectSet(Grid2+IndiCopyOnChart, OBJPROP_COLOR,GridColor);
      ObjectSet(Grid2+IndiCopyOnChart, OBJPROP_WIDTH ,GridSize);
      ObjectSet(Grid2+IndiCopyOnChart, OBJPROP_STYLE ,GridStyle);      
      } 
      
  
  }
    if(SeeTimeCycles && ObjectFind(Cycler+IndiCopyOnChart)==0)
  {
  
      ObjectSet(Cycler+IndiCopyOnChart, OBJPROP_COLOR,TimeCycleColor);
      ObjectSet(Cycler+IndiCopyOnChart, OBJPROP_WIDTH ,TimeCycleSize);
      ObjectSet(Cycler+IndiCopyOnChart, OBJPROP_STYLE ,TimeCycleStyle);
      ObjectSet(Cycler+IndiCopyOnChart, OBJPROP_PRICE1 ,price1); 
      ObjectSet(Cycler+IndiCopyOnChart, OBJPROP_PRICE2 ,price1);
      ObjectSet(Cycler+IndiCopyOnChart, OBJPROP_TIME2 ,Time[iBarShift(NULL,0,lowtime)-Cycle_Bars]);
      ObjectSet(Cycler+IndiCopyOnChart, OBJPROP_TIME1 ,lowtime);
      
            if(SeeGrid && ObjectFind(Grid+IndiCopyOnChart)==0)
      {
      ObjectSet(Grid+IndiCopyOnChart, OBJPROP_COLOR,GridColor);
      ObjectSet(Grid+IndiCopyOnChart, OBJPROP_WIDTH ,GridSize);
      ObjectSet(Grid+IndiCopyOnChart, OBJPROP_STYLE ,GridStyle);
      ObjectSet(Grid+IndiCopyOnChart, OBJPROP_PRICE1 ,thelow); 
      ObjectSet(Grid+IndiCopyOnChart, OBJPROP_PRICE2 ,thehigh);
      ObjectSet(Grid+IndiCopyOnChart, OBJPROP_TIME2 ,Time[iBarShift(NULL,0,lowtime)-Cycle_Bars]);
      ObjectSet(Grid+IndiCopyOnChart, OBJPROP_TIME1 ,lowtime);
      
      ObjectSet(Grid2+IndiCopyOnChart, OBJPROP_COLOR,GridColor);
      ObjectSet(Grid2+IndiCopyOnChart, OBJPROP_WIDTH ,GridSize);
      ObjectSet(Grid2+IndiCopyOnChart, OBJPROP_STYLE ,GridStyle);
      ObjectSet(Grid2+IndiCopyOnChart, OBJPROP_PRICE1 ,thehigh); 
      ObjectSet(Grid2+IndiCopyOnChart, OBJPROP_PRICE2 ,thelow);
      ObjectSet(Grid2+IndiCopyOnChart, OBJPROP_TIME2 ,Time[iBarShift(NULL,0,lowtime)-Cycle_Bars]);
      ObjectSet(Grid2+IndiCopyOnChart, OBJPROP_TIME1 ,lowtime);
      
      }
  }
}

//--------------------------------------------------------------------------------------------------Up Levels-------------+
if(SeeUpperCycleLines)
{
if(ObjectFind(txtUp1+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtUp1+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thelow);      

      ObjectSet(txtUp1+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtUp1+IndiCopyOnChart, OBJPROP_RAY ,True);    
      ObjectSet(txtUp1+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtUp1+IndiCopyOnChart)==0)
{
ObjectSet(txtUp1+IndiCopyOnChart,  OBJPROP_PRICE1,thelow);
      ObjectSet(txtUp1+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
       ObjectSet(txtUp1+IndiCopyOnChart, OBJPROP_COLOR,CalcUpColor);     
}
//---- 
if(ObjectFind(txtUp2+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtUp2+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thelow+(ratio1*thelow));      
      
      ObjectSet(txtUp2+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtUp2+IndiCopyOnChart, OBJPROP_RAY ,True);    
       ObjectSet(txtUp2+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtUp2+IndiCopyOnChart)==0)
{
ObjectSet(txtUp2+IndiCopyOnChart,  OBJPROP_PRICE1,thelow+(ratio1*thelow));
ObjectSet(txtUp2+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtUp2+IndiCopyOnChart, OBJPROP_COLOR,Degree_45);
}
//---- 
if(ObjectFind(txtUp3+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtUp3+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thelow+(ratio2*thelow));      
      
      ObjectSet(txtUp3+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtUp3+IndiCopyOnChart, OBJPROP_RAY ,True);    
       ObjectSet(txtUp3+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtUp3+IndiCopyOnChart)==0)
{
ObjectSet(txtUp3+IndiCopyOnChart,  OBJPROP_PRICE1,thelow+(ratio2*thelow));
ObjectSet(txtUp3+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtUp3+IndiCopyOnChart, OBJPROP_COLOR,Degree_90);
}
//---- 
if(ObjectFind(txtUp4+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtUp4+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thelow+(ratio3*thelow));      
      
      ObjectSet(txtUp4+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtUp4+IndiCopyOnChart, OBJPROP_RAY ,True);    
       ObjectSet(txtUp4+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtUp4+IndiCopyOnChart)==0)
{
ObjectSet(txtUp4+IndiCopyOnChart,  OBJPROP_PRICE1,thelow+(ratio3*thelow));
ObjectSet(txtUp4+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtUp4+IndiCopyOnChart, OBJPROP_COLOR,Degree_120);
}
//---- 
if(ObjectFind(txtUp5+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtUp5+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thelow+(ratio4*thelow));      
      
      ObjectSet(txtUp5+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtUp5+IndiCopyOnChart, OBJPROP_RAY ,True);    
       ObjectSet(txtUp5+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtUp5+IndiCopyOnChart)==0)
{
ObjectSet(txtUp5+IndiCopyOnChart,  OBJPROP_PRICE1,thelow+(ratio4*thelow));
ObjectSet(txtUp5+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtUp5+IndiCopyOnChart, OBJPROP_COLOR,Degree_135);

}
//---- 

//---- 
if(ObjectFind(txtUp6+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtUp6+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thelow+(ratio5*thelow));      
      
      ObjectSet(txtUp6+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtUp6+IndiCopyOnChart, OBJPROP_RAY ,True);    
       ObjectSet(txtUp6+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtUp6+IndiCopyOnChart)==0)
{
ObjectSet(txtUp6+IndiCopyOnChart,  OBJPROP_PRICE1,thelow+(ratio5*thelow));
ObjectSet(txtUp6+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtUp6+IndiCopyOnChart, OBJPROP_COLOR,Degree_180);

}
//---- 
if(ObjectFind(txtUp7+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtUp7+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thelow+(ratio6*thelow));      
      
      ObjectSet(txtUp7+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtUp7+IndiCopyOnChart, OBJPROP_RAY ,True);    
       ObjectSet(txtUp7+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtUp7+IndiCopyOnChart)==0)
{
ObjectSet(txtUp7+IndiCopyOnChart,  OBJPROP_PRICE1,thelow+(ratio6*thelow));
ObjectSet(txtUp7+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtUp7+IndiCopyOnChart, OBJPROP_COLOR,Degree_225);

}
//---- 
if(ObjectFind(txtUp8+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtUp8+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thelow+(ratio7*thelow));      
      
      ObjectSet(txtUp8+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtUp8+IndiCopyOnChart, OBJPROP_RAY ,True);    
       ObjectSet(txtUp8+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtUp8+IndiCopyOnChart)==0)
{
ObjectSet(txtUp8+IndiCopyOnChart,  OBJPROP_PRICE1,thelow+(ratio7*thelow));
ObjectSet(txtUp8+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtUp8+IndiCopyOnChart, OBJPROP_COLOR,Degree_240);

}
//----     
 if(ObjectFind(txtUp9+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtUp9+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thelow+(ratio8*thelow));      
      
      ObjectSet(txtUp9+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtUp9+IndiCopyOnChart, OBJPROP_RAY ,True);    
       ObjectSet(txtUp9+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtUp9+IndiCopyOnChart)==0)
{
ObjectSet(txtUp9+IndiCopyOnChart,  OBJPROP_PRICE1,thelow+(ratio8*thelow));
ObjectSet(txtUp9+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtUp9+IndiCopyOnChart, OBJPROP_COLOR,Degree_270);

}     
//----     
 if(ObjectFind(txtUp10+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtUp10+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thelow+(ratio9*thelow));      
      
      ObjectSet(txtUp10+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtUp10+IndiCopyOnChart, OBJPROP_RAY ,True);    
       ObjectSet(txtUp10+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtUp10+IndiCopyOnChart)==0)
{
ObjectSet(txtUp10+IndiCopyOnChart,  OBJPROP_PRICE1,thelow+(ratio9*thelow));
ObjectSet(txtUp10+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtUp10+IndiCopyOnChart, OBJPROP_COLOR,Degree_315);

}     
//----     
 if(ObjectFind(txtUp11+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtUp11+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thelow+(ratio10*thelow));      
      
      ObjectSet(txtUp11+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtUp11+IndiCopyOnChart, OBJPROP_RAY ,True);    
       ObjectSet(txtUp11+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtUp11+IndiCopyOnChart)==0)
{
ObjectSet(txtUp11+IndiCopyOnChart,  OBJPROP_PRICE1,thelow+(ratio10*thelow));
ObjectSet(txtUp11+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtUp11+IndiCopyOnChart, OBJPROP_COLOR,Degree_360);

} 
}
//-----------------------------------------------------------------------------------------------Dn Levels---------------+
if(SeeLowerCycleLines)
{
if(ObjectFind(txtDn1+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtDn1+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thehigh);      
      
      ObjectSet(txtDn1+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtDn1+IndiCopyOnChart, OBJPROP_RAY ,True);    
       ObjectSet(txtDn1+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtDn1+IndiCopyOnChart)==0)
{
ObjectSet(txtDn1+IndiCopyOnChart,  OBJPROP_PRICE1,thehigh);
ObjectSet(txtDn1+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtDn1+IndiCopyOnChart, OBJPROP_COLOR,CalcDnColor);

}
//---- 
if(ObjectFind(txtDn2+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtDn2+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thehigh-(ratio1*thehigh));      
      
      ObjectSet(txtDn2+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtDn2+IndiCopyOnChart, OBJPROP_RAY ,True);    
      ObjectSet(txtDn2+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtDn2+IndiCopyOnChart)==0)
{
ObjectSet(txtDn2+IndiCopyOnChart,  OBJPROP_PRICE1,thehigh-(ratio1*thehigh));
ObjectSet(txtDn2+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtDn2+IndiCopyOnChart, OBJPROP_COLOR,Degree_45);

}
//---- 
if(ObjectFind(txtDn3+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtDn3+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thehigh-(ratio2*thehigh));      
      
      ObjectSet(txtDn3+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtDn3+IndiCopyOnChart, OBJPROP_RAY ,True);    
      ObjectSet(txtDn3+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtDn3+IndiCopyOnChart)==0)
{
ObjectSet(txtDn3+IndiCopyOnChart,  OBJPROP_PRICE1,thehigh-(ratio2*thehigh));
ObjectSet(txtDn3+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtDn3+IndiCopyOnChart, OBJPROP_COLOR,Degree_90);

}
//---- 
if(ObjectFind(txtDn4+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtDn4+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thehigh-(ratio3*thehigh));      
      
      ObjectSet(txtDn4+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtDn4+IndiCopyOnChart, OBJPROP_RAY ,True);    
      ObjectSet(txtDn4+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtDn4+IndiCopyOnChart)==0)
{
ObjectSet(txtDn4+IndiCopyOnChart,  OBJPROP_PRICE1,thehigh-(ratio3*thehigh));
ObjectSet(txtDn4+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtDn4+IndiCopyOnChart, OBJPROP_COLOR,Degree_120);

}
//---- 
if(ObjectFind(txtDn5+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtDn5+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thehigh-(ratio4*thehigh));      
      
      ObjectSet(txtDn5+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtDn5+IndiCopyOnChart, OBJPROP_RAY ,True);    
      ObjectSet(txtDn5+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtDn5+IndiCopyOnChart)==0)
{
ObjectSet(txtDn5+IndiCopyOnChart,  OBJPROP_PRICE1,thehigh-(ratio4*thehigh));
ObjectSet(txtDn5+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtDn5+IndiCopyOnChart, OBJPROP_COLOR,Degree_135);

}
//---- 
if(ObjectFind(txtDn6+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtDn6+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thehigh-(ratio5*thehigh));      
      
      ObjectSet(txtDn6+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtDn6+IndiCopyOnChart, OBJPROP_RAY ,True);    
      ObjectSet(txtDn6+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtDn6+IndiCopyOnChart)==0)
{
ObjectSet(txtDn6+IndiCopyOnChart,  OBJPROP_PRICE1,thehigh-(ratio5*thehigh));
ObjectSet(txtDn6+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtDn6+IndiCopyOnChart, OBJPROP_COLOR,Degree_180);

}
//---- 
if(ObjectFind(txtDn7+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtDn7+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thehigh-(ratio6*thehigh));      
      
      ObjectSet(txtDn7+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtDn7+IndiCopyOnChart, OBJPROP_RAY ,True);    
      ObjectSet(txtDn7+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtDn7+IndiCopyOnChart)==0)
{
ObjectSet(txtDn7+IndiCopyOnChart,  OBJPROP_PRICE1,thehigh-(ratio6*thehigh));
ObjectSet(txtDn7+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtDn7+IndiCopyOnChart, OBJPROP_COLOR,Degree_225);

}
//---- 
if(ObjectFind(txtDn8+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtDn8+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thehigh-(ratio7*thehigh));      
      
      ObjectSet(txtDn8+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtDn8+IndiCopyOnChart, OBJPROP_RAY ,True);    
      ObjectSet(txtDn8+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtDn8+IndiCopyOnChart)==0)
{
ObjectSet(txtDn8+IndiCopyOnChart,  OBJPROP_PRICE1,thehigh-(ratio7*thehigh));
ObjectSet(txtDn8+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtDn8+IndiCopyOnChart, OBJPROP_COLOR,Degree_240);

}
//---- 
     
 if(ObjectFind(txtDn9+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtDn9+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thehigh-(ratio8*thehigh));      
      
      ObjectSet(txtDn9+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtDn9+IndiCopyOnChart, OBJPROP_RAY ,True);    
      ObjectSet(txtDn9+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtDn9+IndiCopyOnChart)==0)
{
ObjectSet(txtDn9+IndiCopyOnChart,  OBJPROP_PRICE1,thehigh-(ratio8*thehigh));
ObjectSet(txtDn9+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtDn9+IndiCopyOnChart, OBJPROP_COLOR,Degree_270);

}     
//----     
 if(ObjectFind(txtDn10+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtDn10+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thehigh-(ratio9*thehigh));      
      
      ObjectSet(txtDn10+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtDn10+IndiCopyOnChart, OBJPROP_RAY ,True);    
      ObjectSet(txtDn10+IndiCopyOnChart, OBJPROP_BACK ,True);
}  
if(ObjectFind(txtDn10+IndiCopyOnChart)==0)
{
ObjectSet(txtDn10+IndiCopyOnChart,  OBJPROP_PRICE1,thehigh-(ratio9*thehigh));
ObjectSet(txtDn10+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtDn10+IndiCopyOnChart, OBJPROP_COLOR,Degree_315);

}     
//----     
 if(ObjectFind(txtDn11+IndiCopyOnChart)!=0)
{
      ObjectCreate(txtDn11+IndiCopyOnChart,OBJ_HLINE,0,Time[0],thehigh-(ratio10*thehigh));      
      
      ObjectSet(txtDn11+IndiCopyOnChart, OBJPROP_WIDTH ,CalcSize);      
      ObjectSet(txtDn11+IndiCopyOnChart, OBJPROP_RAY ,True);    
      ObjectSet(txtDn11+IndiCopyOnChart, OBJPROP_BACK ,True);

}  
if(ObjectFind(txtDn11+IndiCopyOnChart)==0)
{
ObjectSet(txtDn11+IndiCopyOnChart,  OBJPROP_PRICE1,thehigh-(ratio10*thehigh));
ObjectSet(txtDn11+IndiCopyOnChart, OBJPROP_STYLE ,CalcStyle);
ObjectSet(txtDn11+IndiCopyOnChart, OBJPROP_COLOR,Degree_360);

} 

}

//-----------------------------------Square 
if(SeeShadeBox)
{


 if(ObjectFind(Gbox1+IndiCopyOnChart)!=0 )   
{
      ObjectCreate(Gbox1+IndiCopyOnChart,OBJ_RECTANGLE,0,price1,Time[0],price2,Time[0]); //     
   
      ObjectSet(Gbox1+IndiCopyOnChart, OBJPROP_BACK ,True);
      ObjectSet(Gbox1+IndiCopyOnChart, OBJPROP_COLOR,ShadeColor);
} 




 if(ObjectFind(GCirc1+IndiCopyOnChart)!=0 )  
{
      ObjectCreate(GCirc1+IndiCopyOnChart,OBJ_ELLIPSE,0,price1,Time[0],price2,Time[0],price2,Time[0]); //     
   
      ObjectSet(GCirc1+IndiCopyOnChart, OBJPROP_BACK ,True);
      ObjectSet(GCirc1+IndiCopyOnChart, OBJPROP_COLOR,ShadeColor);
}


//------------------------

 if(ObjectFind(Gbox1+IndiCopyOnChart)==0 )
 {
        ObjectSet(Gbox1+IndiCopyOnChart,  OBJPROP_PRICE1,price1);
        ObjectSet(Gbox1+IndiCopyOnChart,  OBJPROP_PRICE2,price2);
        ObjectSet(Gbox1+IndiCopyOnChart,  OBJPROP_TIME1,lowtime);
        int cycleforward=Cycle_Bars*AutoCycleDivisor;
        ObjectSet(Gbox1+IndiCopyOnChart,  OBJPROP_TIME2,Time[iBarShift(NULL,0,lowtime)-cycleforward]);    
        
       ObjectSet(Gbox1+IndiCopyOnChart, OBJPROP_BACK ,True);
       ObjectSet(Gbox1+IndiCopyOnChart, OBJPROP_COLOR,ShadeColor);
 }
 if(ObjectFind(GCirc1+IndiCopyOnChart)==0 )
 {
        ObjectSet(GCirc1+IndiCopyOnChart,  OBJPROP_PRICE1,thelow+((thehigh-thelow)*0.5));
        ObjectSet(GCirc1+IndiCopyOnChart,  OBJPROP_PRICE2,thehigh-((thehigh-thelow)*0.5));
        ObjectSet(GCirc1+IndiCopyOnChart,  OBJPROP_PRICE3,thehigh+((thehigh-thelow)*0.5));
        
        ObjectSet(GCirc1+IndiCopyOnChart,  OBJPROP_TIME1,Time[iBarShift(NULL,0,lowtime) ]);
        
        
        ObjectSet(GCirc1+IndiCopyOnChart,  OBJPROP_SCALE,1); // 
        
        int halfcycleforward=Cycle_Bars*AutoCycleDivisor;
        ObjectSet(GCirc1+IndiCopyOnChart,  OBJPROP_TIME2,Time[iBarShift(NULL,0,lowtime)-(cycleforward)]); //    
        
       ObjectSet(GCirc1+IndiCopyOnChart, OBJPROP_BACK ,True);       ObjectSet(GCirc1+IndiCopyOnChart, OBJPROP_COLOR,ShadeColor);
 }
 
}

//-----------------------------------fiboarc--------------------+
if(SeeArcs)
{
     int Halfcycleforwardcentre = cycleforward*0.5;
      
     if(ObjectFind(Arc1+IndiCopyOnChart)!=0 )
      {
      ObjectCreate(Arc1+IndiCopyOnChart,OBJ_FIBOARC,0,0,0,0,0);
      }
     if(ObjectFind(Arc2+IndiCopyOnChart)!=0 )
      {
      ObjectCreate(Arc2+IndiCopyOnChart,OBJ_FIBOARC,0,0,0,0,0);
      }
     if(ObjectFind(Arc1+IndiCopyOnChart)==0 )
      {
      
        ObjectSet(Arc1+IndiCopyOnChart,  OBJPROP_PRICE2,thelow+((thehigh-thelow)*0.5));
        ObjectSet(Arc1+IndiCopyOnChart,  OBJPROP_PRICE1,thehigh);
        
        ObjectSet(Arc1+IndiCopyOnChart,  OBJPROP_TIME1,lowtime);
        ObjectSet(Arc1+IndiCopyOnChart,  OBJPROP_TIME2,Time[iBarShift(NULL,0,lowtime)-(Halfcycleforwardcentre)]);
        
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_COLOR,ArcColor);
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_WIDTH ,0);
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_RAY,True);
       
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_LEVELSTYLE,0);
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_LEVELCOLOR,ArcColor);      
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_LEVELWIDTH,1);  
       
          
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_FIBOLEVELS,10);
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+0,C1ratio1*ArcRatio);
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+1,C1ratio2*ArcRatio);
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+2,C1ratio3*ArcRatio);
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+3,C1ratio4*ArcRatio);
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+4,C1ratio5*ArcRatio);
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+5,C1ratio6*ArcRatio);
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+6,C1ratio7*ArcRatio);
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+7,C1ratio8*ArcRatio);
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+8,C1ratio9*ArcRatio);
      ObjectSet(Arc1+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+9,C1ratio10*ArcRatio);
      }
     if(ObjectFind(Arc2+IndiCopyOnChart)==0 )
      {
      
        ObjectSet(Arc2+IndiCopyOnChart,  OBJPROP_PRICE2,thelow+((thehigh-thelow)*0.5));
        ObjectSet(Arc2+IndiCopyOnChart,  OBJPROP_PRICE1,thelow);
        
        ObjectSet(Arc2+IndiCopyOnChart,  OBJPROP_TIME1,lowtime);
        ObjectSet(Arc2+IndiCopyOnChart,  OBJPROP_TIME2,Time[iBarShift(NULL,0,lowtime)-(Halfcycleforwardcentre)]);
        
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_COLOR,ArcColor);
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_WIDTH ,0);
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_RAY,True);
       
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_LEVELSTYLE,0);
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_LEVELCOLOR,ArcColor);      
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_LEVELWIDTH,1);  
       
          
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_FIBOLEVELS,10);
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+0,C1ratio1*ArcRatio);
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+1,C1ratio2*ArcRatio);
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+2,C1ratio3*ArcRatio);
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+3,C1ratio4*ArcRatio);
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+4,C1ratio5*ArcRatio);
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+5,C1ratio6*ArcRatio);
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+6,C1ratio7*ArcRatio);
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+7,C1ratio8*ArcRatio);
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+8,C1ratio9*ArcRatio);
      ObjectSet(Arc2+IndiCopyOnChart, OBJPROP_FIRSTLEVEL+9,C1ratio10*ArcRatio);
      }
      
}
//-comments
if(SeeComment)
{


string Space = "+..............+";
string Blurb="";

  string newline = "\n";
     Comment(
      newline,
      " Coded By www.Brooky-Indicators.com for MoneyDeep",newline,
      Space,newline,
      "--Circle Num Used-->>",DoubleToStr(SelectCircleToUse,0),newline,
      "--Cycle Bars Used-->>",DoubleToStr(Cycle_Bars,0),newline,
      "--Square Height Pips-->>",DoubleToStr(CbarRange,0),newline,
      "--Square Width Bars-->>",DoubleToStr(Cycle_Bars*AutoCycleDivisor,0),newline,
      "--Square H/W Ratio -->> 1 : ",DoubleToStr((Cycle_Bars*AutoCycleDivisor)/CbarRange,2),newline
      
      );
   
   
}
   return(0);
  }